<template>
  <div>
    <!-- Contenido -->
    <div class="">
      <!--<div class="titSecCard">Descargar Excel de Certificación de Puntos de Venta</div>-->
      <v-card style="background-color: #fafafa">
        <v-container fluid>
          <div class="indicaciones" align="center" justify="center">
            Filtro de Reporte
          </div>

          <v-row align="center" justify="center">
            <!-- Negocio -->
            <!-- FECHA INICIO -->
            <v-col cols="4">
              <div class="titCampos">Fecha Inicio</div>
              <v-flex>
                <v-menu
                  ref="menuInicio"
                  v-model="menuInicio"
                  :close-on-content-click="false"
                  :nudge-right="40"
                  transition="scale-transition"
                  offset-y
                  min-width="290px"
                >
                  <template v-slot:activator="{ on }">
                    <v-text-field
                      ref="fechaInicioTF"
                      outlined
                      dense
                      v-model="fechaInicio"
                      placeholder="Selecciona una fecha inicio"
                      prepend-icon
                      readonly
                      v-on="on"
                      :rules="[
                        () =>
                          !!fechaInicio || 'Debes seleccionar la fecha Inicio',
                      ]"
                      prepend-inner-icon="mdi-calendar-month"
                    ></v-text-field>
                  </template>

                  <v-date-picker
                    v-model="fechaInicio"
                    @input="menuInicio = false"
                    header-color="#ffc900"
                    color="#ffeeb2"
                    @click="$refs.menuInicio.save(fechaInicio)"
                  >
                  </v-date-picker>
                </v-menu>
              </v-flex>
            </v-col>
            <!-- FECHA FIN -->
            <v-col cols="4">
              <div class="titCampos">Fecha Fin</div>
              <v-flex>
                <v-menu
                  ref="menuFin"
                  v-model="menuFin"
                  :close-on-content-click="false"
                  :nudge-right="40"
                  transition="scale-transition"
                  offset-y
                  min-width="290px"
                >
                  <template v-slot:activator="{ on }">
                    <v-text-field
                      ref="fechFinTF"
                      outlined
                      dense
                      v-model="fechaFin"
                      placeholder="Selecciona una fecha fin"
                      prepend-icon
                      readonly
                      v-on="on"
                      :rules="[
                        () => !!fechaFin || 'Debes seleccionar la fecha fin',
                      ]"
                      prepend-inner-icon="mdi-calendar-month"
                    ></v-text-field>
                  </template>

                  <v-date-picker
                    v-model="fechaFin"
                    @input="menuFin = false"
                    header-color="#ffc900"
                    color="#ffeeb2"
                    @click="$refs.menuFin.save(fechaFin)"
                  >
                  </v-date-picker>
                </v-menu>
              </v-flex>
            </v-col>

            <!--ICU DEL DISPOSITIVO-->
            <v-col cols="4">
              <div class="titCampos">ICU del dispositivo</div>
              <v-flex style="">
                <v-text-field
                  hide-details="true"
                  placeholder="Seleccione el ICU del dispositivo"
                  v-model="icu"
                  outlined
                  dense
                ></v-text-field>
              </v-flex>

              <div class="">*Opcional</div>
            </v-col>
          </v-row>
          <br />
          <v-row align="center" justify="center">
            <!-- BUSCAR -->
            <v-col cols="4"></v-col>
            <v-col cols="4">
              <v-btn block color="primary" @click="downloadReportExcel" dark>
                <strong style="font-size: 16px; color: #000">Descargar</strong>
              </v-btn>
            </v-col>
            <v-col cols="4"></v-col>
          </v-row>
        </v-container>
      </v-card>
    </div>
    <!-- Fin conSecc -->
  </div>
</template>
<style scoped></style>
<script>
import FileSaver from "file-saver";
import router from "@/router";
import store from "@/store";
const axiosChecklist = store.state.axiosChecklist;
import axios from "axios";

const serviceCommons = store.state.serviceCommons;
export default {
  name: "DescargarReporteICU",
  data() {
    return {
      menuInicio: false,
      menuFin: false,

      fechaInicio: "",
      fechaFin: "",

      icu: "",

      metadata: {},
      search: "",
    };
  },
  methods: {
    downloadReportExcel() {
      const self = this;

      let fecha_inicio = "";
      let fecha_fin = "";
      if (this.fechaInicio && this.fechaFin) {
        if (this.fechaInicio) {
          let dia = this.fechaInicio.split("-")[2];
          let mes = this.fechaInicio.split("-")[1];
          let anio = this.fechaInicio.split("-")[0];
          fecha_inicio = dia + "/" + mes + "/" + anio;
        }

        if (this.fechaFin) {
          let dia = this.fechaFin.split("-")[2];
          let mes = this.fechaFin.split("-")[1];
          let anio = this.fechaFin.split("-")[0];
          fecha_fin = dia + "/" + mes + "/" + anio;
        }
        this.consumeServicioWifi(
          "/wifi-sucursales/v1/gobierno-datos/icu?fechaInicio=" +
            fecha_inicio +
            "&fechaFin=" +
            fecha_fin +
            "&identificadorCliente=" +
            this.icu
        );
      }
    },
    consumeServicioWifi(url) {
      axios
        .get(url, {
          headers: {
            "Content-Type": "application/json;charset=UTF-8",
          },
          data: {}, // envío un cuerpo (aunque sea un objeto vacío)
        })
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data["Identificadores de Clientes"]) {
                this.exportToExcel(data["Identificadores de Clientes"]);
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        });
    },
    exportToExcel(data) {
      const dataFinal = { data };
      //dataFinal[data] = data;
      axios({
        method: "post",
        url: "/json/convert/secure/array/excel",
        responseType: "blob",
        data: dataFinal,
      })
        .then((response) => {
          if (response.headers["content-type"] !== "application/json") {
            FileSaver.saveAs(response.data, response.headers["file-name"]);
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function () {});
    },
  },

  created() {},
};
</script>
